------ Variables ------
local M = {}
local modAttached = false
local override = false
------ Functions ------
local function breakConnectingBeams() -- searches and breaks related beams  
    for k, beam in pairs(v.data.beams) do -- loop for each beam 
        if (string.find(tostring(beam.breakGroup), "_Openable") ~= nil) then
            modAttached = true
        end
        if beam.breakGroup ~= nil and beam.breakGroup ~= "" then -- if beam contains a breakGroup
            if string.find(tostring(beam.breakGroup), "hoodlatch") ~= nil or -- if beam is for the hood
                string.find(tostring(beam.breakGroup), "tailgatelatch") ~= nil or -- or if beam is for the tailgate
                string.find(tostring(beam.breakGroup), "trunklatch") ~= nil or -- or if beam is for the trunk
                string.find(tostring(beam.breakGroup), "doorlatch") ~= nil then -- or if beam is for a door
                if string.find(tostring(beam.breakGroup), "_Openable") == nil then -- if beam hasnt be added by this mod
                    if (modAttached or override) then
                        obj:breakBeam(k) -- breaks beam
                    end
                end
            end
            ------ Wendover Extra Bits ------
            if string.find(tostring(v.data.options.partName), "wendover") then
                if string.find(tostring(beam.breakGroupType), "1") ~= nil and
                    string.find(tostring(beam.breakGroup), "hoodhinge") then
                    if string.find(tostring(beam.breakGroup), "_Openable") == nil then -- if beam hasnt be added by this mod
                        if (modAttached or override) then
                            obj:breakBeam(k) -- breaks beam
                        end
                    end
                end
                if string.find(tostring(beam.beamType), "BOUNDED") ~= nil and
                    string.find(tostring(beam.breakGroup), "hoodhinge") then
                    if string.find(tostring(beam.breakGroup), "_Openable") == nil then -- if beam hasnt be added by this mod
                        if (modAttached or override) then
                            obj:breakBeam(k) -- breaks beam
                        end
                    end
                end
            end
        end
    end
   
    if (modAttached) then
        if string.find(tostring(v.data.options.partName), "etk800") then
            etk800DoorNode1 = getNodeID('d17l')
            etk800DoorNode2 = getNodeID('d17r')
        end
        for k, node in pairs(v.data.nodes) do
             ------ ETKI Adjust Door Nodes to Prevent Clipping------
            if string.find(tostring(v.data.options.partName), "etki") then
                if (k == 77) or (k == 71) or (k == 78) or (k == 72) then
                    -- print(tostring(node.x))
                    print(tostring(vec3(obj:getNodePosition(node.cid))))
                    obj:setNodePosition(node.cid, (vec3(obj:getNodePosition(node.cid)) - vec3(0, 0.01, 0)):toFloat3())
                end
            end

             ------ ETK 800 preventing windows from breaking------
            if string.find(tostring(v.data.options.partName), "etk800") then
                if (k == 1) then
                    -- print(tostring(node.x))
                    AdjustSpringStrength('d7l', 'd8l', 0)
                    AdjustSpringStrength('d7l', 'd9l', 0)
                    AdjustSpringStrength('d7l', 'd10l', 0)
                    AdjustSpringStrength('d7l', 'd11l', 0)
                    AdjustSpringStrength('d7l', 'd12l', 0)
                    AdjustSpringStrength('d7l', 'd13l', 0)

                    AdjustSpringStrength('d7r', 'd8r', 0)
                    AdjustSpringStrength('d7r', 'd9r', 0)
                    AdjustSpringStrength('d7r', 'd10r', 0)
                    AdjustSpringStrength('d7r', 'd11r', 0)
                    AdjustSpringStrength('d7r', 'd12r', 0)
                    AdjustSpringStrength('d7r', 'd13r', 0)

                end
                ------ move nodes (looking for a better solution)
                if (k == etk800DoorNode1) then
                    print(tostring(vec3(obj:getNodePosition(node.cid))))
                    obj:setNodePosition(node.cid, (vec3(obj:getNodePosition(node.cid)) - vec3(0.05, 0, 0)):toFloat3())
                end
                if (k == etk800DoorNode2) then
                    print(tostring(vec3(obj:getNodePosition(node.cid))))
                    obj:setNodePosition(node.cid, (vec3(obj:getNodePosition(node.cid)) + vec3(0.05, 0, 0)):toFloat3())
                end
            end
        end
    end
end

function AdjustSpringStrength(node1, node2, strength)

    node1 = getNodeID(node1)
    node2 = getNodeID(node2)

    for k, beam in pairs(v.data.beams) do
        if beam.id1 == node1 and beam.id2 == node2 then

            beam.beamDamp = strength
            beam.beamSpring = strength

            print(beam.beamDamp)
            print(beam.id1)
            print(beam.id2)
            obj:setBeamSpringDamp(beam.cid, beam.beamSpring, beam.beamDamp, -1, -1)

        end
        if beam.id2 == node1 and beam.id1 == node2 then

            beam.beamDamp = strength
            beam.beamSpring = strength

            print(beam.beamDamp)
            print(beam.id1)
            print(beam.id2)
            obj:setBeamSpringDamp(beam.cid, beam.beamSpring, beam.beamDamp, -1, -1)

        end
    end
end

function getNodeID(name)
    nodeID = nil
    for k, node in pairs(v.data.nodes) do
        if string.match(tostring(node.name), tostring(name)) then
            nodeID = node.cid
        end
    end
    return nodeID
end

M.onReset = breakConnectingBeams -- function to be called when vehicle resets

return M -- return module

